This document explains how to create virtual machine (VM) instances in bulk that use the A2 series, which includes A2 Ultra or A2 Standard machine types. To learn more about these accelerator-optimized machine types, see A2 series.
For more information about creating VMs in bulk, see About bulk creation of VMs in the Compute Engine documentation.
To learn about other ways to create VMs or clusters, see Deployment options overview.
Limitations
When you create A2 Ultra or A2 Standard VMs in bulk, the following limitations apply:
A2 Ultra
- You don't receive sustained use discounts and flexible committed use discounts for instances that use an A2 Ultra machine type.
- You can only use an A2 Ultra machine type in certain regions and zones.
- The A2 Ultra machine type is only available on the Cascade Lake platform.
- If your instance uses an A2 Ultra machine type, you can't change the machine type. If you need to use a different A2 Ultra machine type, or any other machine type, you must create a new instance.
- You can't change any other machine type to an A2 Ultra machine type. If you need a instance that uses an A2 Ultra machine type, you must create a new instance.
- You can't do a quick format of the attached Local SSDs on Windows instances that use A2 Ultra
machine types. To format these Local SSDs, you must do a full format by using the diskpart
utility and specifying
format fs=ntfs label=tmpfs.
A2 Standard
- You don't receive sustained use discounts and flexible committed use discounts for instances that use an A2 Standard machine type.
- You can only use an A2 Standard machine type in certain regions and zones.
- The A2 Standard machine type is only available on the Cascade Lake platform.
- If your instance uses an A2 Standard machine type, you can only switch from one A2 Standard machine type type to another A2 Standard machine type. You can't change to any other machine type. For more information, see Modify accelerator-optimized instances.
- You can't use the Windows operating system with the
a2-megagpu-16gmachine type. When using a Windows operating system, choose a different A2 Standard machine type. - You can't do a quick format of the attached Local SSDs on Windows instances that use A2 Standard machine types.
To format these Local SSDs, you must do a full format by using the diskpart
utility and specifying
format fs=ntfs label=tmpfs.
Before you begin
Before creating VMs in bulk, if you haven't already done so, complete the following steps:
- Choose a consumption option: your choice of consumption option determines how you get and use GPU resources. To learn more, see Choose a consumption option.
- Obtain capacity: the process to obtain capacity differs for each consumption option. To learn about the process to obtain capacity for your chosen consumption option, see Capacity overview.
Select the tab for how you plan to use the samples on this page:
Console
When you use the Google Cloud console to access Google Cloud services and APIs, you don't need to set up authentication.
gcloud
In the Google Cloud console, activate Cloud Shell.
At the bottom of the Google Cloud console, a Cloud Shell session starts and displays a command-line prompt. Cloud Shell is a shell environment with the Google Cloud CLI already installed and with values already set for your current project. It can take a few seconds for the session to initialize.
REST
To use the REST API samples on this page in a local development environment, you use the credentials you provide to the gcloud CLI.
Install the Google Cloud CLI.
If you're using an external identity provider (IdP), you must first sign in to the gcloud CLI with your federated identity.
For more information, see Authenticate for using REST in the Google Cloud authentication documentation.
Required roles
To get the permissions that
you need to create VMs in bulk,
ask your administrator to grant you the
Compute Instance Admin (v1) (roles/compute.instanceAdmin.v1) IAM role on the project.
For more information about granting roles, see Manage access to projects, folders, and organizations.
This predefined role contains the permissions required to create VMs in bulk. To see the exact permissions that are required, expand the Required permissions section:
Required permissions
The following permissions are required to create VMs in bulk:
-
compute.instances.createon the project -
To use a custom image to create the VM:
compute.images.useReadOnlyon the image -
To use a snapshot to create the VM:
compute.snapshots.useReadOnlyon the snapshot -
To use an instance template to create the VM:
compute.instanceTemplates.useReadOnlyon the instance template -
To specify a subnet for your VM:
compute.subnetworks.useon the project or on the chosen subnet -
To specify a static IP address for the VM:
compute.addresses.useon the project -
To assign an external IP address to the VM when using a VPC network:
compute.subnetworks.useExternalIpon the project or on the chosen subnet -
To assign a legacy network to the VM:
compute.networks.useon the project -
To assign an external IP address to the VM when using a legacy network:
compute.networks.useExternalIpon the project -
To set VM instance metadata for the VM:
compute.instances.setMetadataon the project -
To set tags for the VM:
compute.instances.setTagson the VM -
To set labels for the VM:
compute.instances.setLabelson the VM -
To set a service account for the VM to use:
compute.instances.setServiceAccounton the VM -
To create a new disk for the VM:
compute.disks.createon the project -
To attach an existing disk in read-only or read-write mode:
compute.disks.useon the disk -
To attach an existing disk in read-only mode:
compute.disks.useReadOnlyon the disk
You might also be able to get these permissions with custom roles or other predefined roles.
Overview
Creating instances in bulk with the A2 machine type includes the following steps:
- Optional: Create a compact placement policy
- Create instances in bulk
- Install GPU drivers
- Optional: Enable NVIDIA Multi-Instance GPU mode
Optional: Create a compact placement policy
You can specify VM placement by creating a compact placement policy. When you apply a compact
placement policy to your VMs, Compute Engine makes best-effort attempts to create VMs that
are as close to each other as possible. If your application is latency-sensitive and requires
maximum compactness, then specify the maxDistance field
(Preview) when you create a
compact placement policy. A lower maxDistance value ensures closer VM placement, but
it also increases the chance that some VMs won't be created.
gcloud
To create a compact placement policy, use the
gcloud beta compute resource-policies create group-placement command:
gcloud beta compute resource-policies create group-placement POLICY_NAME \
--collocation=collocated \
--max-distance=MAX_DISTANCE \
--region=REGION
Replace the following:
POLICY_NAME: the name of the compact placement policy.MAX_DISTANCE: the maximum distance configuration for your VMs, which can either be specified (Preview, recommended) or unspecified (remove the--max-distanceflag). Ensure that the maximum distance configuration supports the machine series and number of VMs that you plan to create. For more information, see About compact placement policies in the Compute Engine documentation. For example, a maximum distance of3places VMs in adjacent blocks and2places VMs in the same block.REGION: the region where you want to create the compact placement policy. Specify the region that contains the zone where you plan to create instances, and verify that the machine type that you want to use is available in that region. For information about regions, see GPU availability by regions and zones.
REST
To create a compact placement policy, make a POST request to the
beta
resourcePolicies.insert method.
In the request body, include the
collocation field set to COLLOCATED, and the maxDistance
field.
POST https://compute.googleapis.com/compute/beta/projects/PROJECT_ID/regions/REGION/resourcePolicies
{
"name": "POLICY_NAME",
"groupPlacementPolicy": {
"collocation": "COLLOCATED",
"maxDistance": MAX_DISTANCE
}
}
Replace the following:
PROJECT_ID: your project ID.POLICY_NAME: the name of the compact placement policy.MAX_DISTANCE: the maximum distance configuration for your VMs, which can either be specified (Preview, recommended) or unspecified (remove themaxDistancefield). Ensure that the maximum distance configuration supports the machine series and number of VMs that you plan to create. For more information, see About compact placement policies in the Compute Engine documentation. For example, a maximum distance of3places VMs in adjacent blocks and2places VMs in the same block.REGION: the region where you want to create the compact placement policy. Specify the region that contains the zone where you plan to create instances, and verify that the machine type that you want to use is available in that region. For information about regions, see GPU availability by regions and zones.
Create A2 VMs in bulk
To create an A2 VM, use one of the following methods.
The following commands also set the access scope for your instances. To simplify permissions management, Google recommends that you set the access scope on an instance tocloud-platform access and then use IAM roles to define what services the instance can
access. For more information, see
Scopes best practice.
gcloud
To create
instances in
bulk, use the
gcloud compute instances bulk create command.
The parameters that you need to specify depend on the consumption option that you are using for this deployment. Select the tab that corresponds to your consumption option.
Reservation
A2 instances support the following types of reservations:
- On-demand reservations
- Standard future reservations
To consume these types of reservations, an instance must use the standard provisioning model. For example, use the following creation parameters.
Before you run the command, review all of the following steps to determine whether to include additional flags.
gcloud compute instances bulk create \
--name-pattern=NAME_PATTERN \
--count=COUNT \
--machine-type=MACHINE_TYPE \
--image-family=IMAGE_FAMILY \
--image-project=IMAGE_PROJECT \
--region=REGION \
--boot-disk-type=DISK_TYPE \
--boot-disk-size=DISK_SIZE \
--scopes=cloud-platform \
--provisioning-model=STANDARD \
--maintenance-policy=TERMINATE \
--reservation-affinity=RESERVATION_AFFINITY \
--reservation=RESERVATION
Complete the following steps:
-
Replace the following:
NAME_PATTERN: the name pattern to use for the A2 instances. For example, usinginstance-#for the name pattern generates A2 instances with names such asinstance-1andinstance-2, up to the number of A2 instances specified by--count.COUNT: the number of A2 instances to create.MACHINE_TYPE: the machine type to use for the A2 instance. For more information, see GPU machine types in the Compute Engine documentation.IMAGE_FAMILY: the image family of the OS image that you want to use. For a list of all supported operating systems, see Supported operating systems.IMAGE_PROJECT: the project ID of the OS image.REGION: specify a region in which the machine type that you want to use is available. If you want to specify a compact placement policy, then you must use the same region as the compact placement policy. For information about regions, see GPU availability by regions and zones.DISK_TYPE: the type of the boot disk. For more information about the supported disk types for your machine type, see GPU machines in accelerator-optimized machine family in the Compute Engine documentation.DISK_SIZE: the size of the boot disk in GB. For more information, see either Google Cloud Hyperdisk size limits or Persistent Disk size limits based on the type of disk.RESERVATION_AFFINITY: which reservations the instance is allowed to consume, if possible. Specify one of the following:any(Reservation capacity is optional): this is the default option. The instance tries to use capacity from an automatically consumed reservation, which only happens if matching reservation capacity is available. Otherwise, the instance uses on-demand capacity.specific(Reservation capacity is required): Require the instance to use capacity from a specifically targeted reservation. The instance isn't allowed to use on-demand capacity. If reservation capacity is unavailable, then the instance creation fails.
RESERVATION: the reservation to use. Specify one of the following based on the value you specified forRESERVATION_AFFINITY:- If you specified
any, then replaceRESERVATIONwith an empty string (""). Alternatively, you can remove the--reservationflag entirely. If you specified
specific, then replaceRESERVATIONwith the following:projects/RESERVATION_OWNER_PROJECT_ID/reservations/RESERVATION_NAME
Replace the following:
RESERVATION_OWNER_PROJECT_ID: the project ID of the project where the reservation was created.RESERVATION_NAME: the name of the reservation.
- If you specified
By default, the instance automatically restarts if it crashes or Compute Engine stops it for a programmed stop, such as a maintenance event. If you want to disable automatic restart, then add the following flag:
--no-restart-on-failure
-
Optional: If you chose to use a compact placement policy, then add the following flag to the command:
--resource-policies=POLICY_NAME
Replace the following:
POLICY_NAME: the name of the compact placement policy.
-
Optional: If you specified an A2 Standard machine type and want to attach Local SSD disks, then add the following
--local-ssdflag for each Local SSD disk.Ensure that the number of Local SSD disks that you attach is allowed for your machine type; for details, see About Local SSD disks in the Compute Engine documentation.
--local-ssd interface=INTERFACE_TYPE
Replace the following:
INTERFACE_TYPE: the disk interface type that you want to use for the Local SSD disk. If your boot disk image has optimized NVMe drivers, then specifyNVME. SpecifySCSIfor other images.
After creating a VM with Local SSD disks, you must format and mount each device before you can use it.
- Run the command.
On-demand
Before you run the command, review all of the following steps to determine whether to include additional flags.
gcloud compute instances bulk create \
--name-pattern=NAME_PATTERN \
--count=COUNT \
--machine-type=MACHINE_TYPE \
--image-family=IMAGE_FAMILY \
--image-project=IMAGE_PROJECT \
--region=REGION \
--boot-disk-type=DISK_TYPE \
--boot-disk-size=DISK_SIZE \
--scopes=cloud-platform \
--provisioning-model=STANDARD \
--maintenance-policy=TERMINATE \
--reservation-affinity=RESERVATION_AFFINITY
Complete the following steps:
-
Replace the following:
NAME_PATTERN: the name pattern to use for the A2 instances. For example, usinginstance-#for the name pattern generates A2 instances with names such asinstance-1andinstance-2, up to the number of A2 instances specified by--count.COUNT: the number of A2 instances to create.MACHINE_TYPE: the machine type to use for the A2 instance. For more information, see GPU machine types in the Compute Engine documentation.IMAGE_FAMILY: the image family of the OS image that you want to use. For a list of all supported operating systems, see Supported operating systems.IMAGE_PROJECT: the project ID of the OS image.REGION: specify a region in which the machine type that you want to use is available. If you want to specify a compact placement policy, then you must use the same region as the compact placement policy. For information about regions, see GPU availability by regions and zones.DISK_TYPE: the type of the boot disk. For more information about the supported disk types for your machine type, see GPU machines in accelerator-optimized machine family in the Compute Engine documentation.DISK_SIZE: the size of the boot disk in GB. For more information, see either Google Cloud Hyperdisk size limits or Persistent Disk size limits based on the type of disk.RESERVATION_AFFINITY: which reservations the instance is allowed to consume, if possible. Specify one of the following:any(Reservation capacity is optional): this is the default option. The instance tries to use capacity from an automatically consumed reservation, which only happens if matching reservation capacity is available. Otherwise, the instance uses on-demand capacity.none(On-demand capacity is required): Block the instance from using any reservation capacity.
By default, the instance automatically restarts if it crashes or Compute Engine stops it for a programmed stop, such as a maintenance event. If you want to disable automatic restart, then add the following flag:
--no-restart-on-failure
-
Optional: If you chose to use a compact placement policy, then add the following flag to the command:
--resource-policies=POLICY_NAME
Replace the following:
POLICY_NAME: the name of the compact placement policy.
-
Optional: If you specified an A2 Standard machine type and want to attach Local SSD disks, then add the following
--local-ssdflag for each Local SSD disk.Ensure that the number of Local SSD disks that you attach is allowed for your machine type; for details, see About Local SSD disks in the Compute Engine documentation.
--local-ssd interface=INTERFACE_TYPE
Replace the following:
INTERFACE_TYPE: the disk interface type that you want to use for the Local SSD disk. If your boot disk image has optimized NVMe drivers, then specifyNVME. SpecifySCSIfor other images.
After creating a VM with Local SSD disks, you must format and mount each device before you can use it.
- Run the command.
Spot
Before you run the command, review all of the following steps to determine whether to include additional flags.
gcloud compute instances bulk create \
--name-pattern=NAME_PATTERN \
--count=COUNT \
--machine-type=MACHINE_TYPE \
--image-family=IMAGE_FAMILY \
--image-project=IMAGE_PROJECT \
--region=REGION \
--boot-disk-type=DISK_TYPE \
--boot-disk-size=DISK_SIZE \
--scopes=cloud-platform \
--provisioning-model=SPOT \
--instance-termination-action=TERMINATION_ACTION \
--maintenance-policy=TERMINATE \
--no-restart-on-failure
Complete the following steps:
-
Replace the following:
NAME_PATTERN: the name pattern to use for the A2 instances. For example, usinginstance-#for the name pattern generates A2 instances with names such asinstance-1andinstance-2, up to the number of A2 instances specified by--count.COUNT: the number of A2 instances to create.MACHINE_TYPE: the machine type to use for the A2 instance. For more information, see GPU machine types in the Compute Engine documentation.IMAGE_FAMILY: the image family of the OS image that you want to use. For a list of all supported operating systems, see Supported operating systems.IMAGE_PROJECT: the project ID of the OS image.REGION: specify a region in which the machine type that you want to use is available. If you want to specify a compact placement policy, then you must use the same region as the compact placement policy. For information about regions, see GPU availability by regions and zones.DISK_TYPE: the type of the boot disk. For more information about the supported disk types for your machine type, see GPU machines in accelerator-optimized machine family in the Compute Engine documentation.DISK_SIZE: the size of the boot disk in GB. For more information, see either Google Cloud Hyperdisk size limits or Persistent Disk size limits based on the type of disk.TERMINATION_ACTION: the action to take when Compute Engine preempts the instance, eitherSTOP(default) orDELETE.
-
Optional: If you chose to use a compact placement policy, then add the following flag to the command:
--resource-policies=POLICY_NAME
Replace the following:
POLICY_NAME: the name of the compact placement policy.
-
Optional: If you specified an A2 Standard machine type and want to attach Local SSD disks, then add the following
--local-ssdflag for each Local SSD disk.Ensure that the number of Local SSD disks that you attach is allowed for your machine type; for details, see About Local SSD disks in the Compute Engine documentation.
--local-ssd interface=INTERFACE_TYPE
Replace the following:
INTERFACE_TYPE: the disk interface type that you want to use for the Local SSD disk. If your boot disk image has optimized NVMe drivers, then specifyNVME. SpecifySCSIfor other images.
After creating a VM with Local SSD disks, you must format and mount each device before you can use it.
- Run the command.
REST
To create
instances in
bulk, make a POST request to the
instances.bulkInsert method.
The parameters that you need to specify depend on the consumption option that you are using for this deployment. Select the tab that corresponds to your consumption option.
Reservation
A2 instances support the following types of reservations:
- On-demand reservations
- Standard future reservations
To consume these types of reservations, an instance must use the standard provisioning model. For example, use the following creation parameters.
Before you submit the request, review all of the following steps to determine whether to include additional fields.
POST https://compute.googleapis.com/compute/v1/projects/PROJECT_ID/zones/ZONE/instances/bulkInsert
{
"namePattern": "NAME_PATTERN",
"count": "COUNT",
"instanceProperties": {
"machineType": "MACHINE_TYPE",
"disks": [
{
"boot": true,
"initializeParams": {
"diskSizeGb": "DISK_SIZE",
"diskType": "DISK_TYPE",
"sourceImage": "projects/IMAGE_PROJECT/global/images/family/IMAGE_FAMILY"
},
"mode": "READ_WRITE",
"type": "PERSISTENT"
}
],
"serviceAccounts": [
{
"email": "default",
"scopes": [
"https://www.googleapis.com/auth/cloud-platform"
]
}
],
"scheduling": {
"provisioningModel": "STANDARD",
"onHostMaintenance": "TERMINATE",
"automaticRestart": AUTOMATIC_RESTART
},
"reservationAffinity": {
"consumeReservationType": "RESERVATION_AFFINITY",
"key": "compute.googleapis.com/reservation-name",
"values": [
"RESERVATION"
]
}
}
}
Complete the following steps:
-
Replace the following:
PROJECT_ID: the project ID of the project where you want to create the A2 instance.ZONE: specify a zone in which the machine type that you want to use is available. If you want to specify a compact placement policy, then you must use a zone in the same region as the compact placement policy. For information about regions, see GPU availability by regions and zones.NAME_PATTERN: the name pattern to use for the A2 instances. For example, usinginstance-#for the name pattern generates A2 instances with names such asinstance-1andinstance-2, up to the number of A2 instances specified by--count.COUNT: the number of A2 instances to create.MACHINE_TYPE: the machine type to use for the A2 instance. For more information, see GPU machine types in the Compute Engine documentation.DISK_SIZE: the size of the boot disk in GB. For more information, see either Google Cloud Hyperdisk size limits or Persistent Disk size limits based on the type of disk.DISK_TYPE: the type of the boot disk. For more information about the supported disk types for your machine type, see GPU machines in accelerator-optimized machine family in the Compute Engine documentation.IMAGE_PROJECT: the project ID of the OS image.IMAGE_FAMILY: the image family of the OS image that you want to use. For a list of all supported operating systems, see Supported operating systems.AUTOMATIC_RESTART: if your instance automatically restarts if it crashes or Compute Engine stops it for a programmed stop, such as a maintenance event. Specify eithertrueto enable automatic restart (default) orfalseto disable automatic restart.RESERVATION_AFFINITY: which reservations the instance is allowed to consume, if possible. Specify one of the following:ANY_RESERVATION(Reservation capacity is optional): this is the default option. The instance tries to use capacity from an automatically consumed reservation, which only happens if matching reservation capacity is available. Otherwise, the instance uses on-demand capacity.SPECIFIC_RESERVATION(Reservation capacity is required): Require the instance to use capacity from a specifically targeted reservation. The instance isn't allowed to use on-demand capacity. If reservation capacity is unavailable, then the instance creation fails.
RESERVATION: the reservation to use. Specify one of the following based on the value you specified forRESERVATION_AFFINITY:- If you specified
ANY_RESERVATION, then deleteRESERVATIONso that the value is an empty string (""). Alternatively, you can remove thekeyandvaluesfields entirely. If you specified
SPECIFIC_RESERVATION, then replaceRESERVATIONwith the following:projects/RESERVATION_OWNER_PROJECT_ID/reservations/RESERVATION_NAME
Replace the following:
RESERVATION_OWNER_PROJECT_ID: the project ID of the project where the reservation was created.RESERVATION_NAME: the name of the reservation.
- If you specified
-
Optional: If you chose to use a compact placement policy, then add the following
instancePropertiessubfield to the request body:"resourcePolicies": [ "projects/PROJECT_ID/regions/REGION/resourcePolicies/POLICY_NAME" ]Replace the following:
PROJECT_ID: the project ID of the compact placement policy.REGION: the region of the compact placement policy.POLICY_NAME: the name of the compact placement policy.
-
Optional: If you specified an A2 Standard machine type and want to attach Local SSD disks, then add the following field to the
disks[]field for each Local SSD disk. Separate eachdisks[]subfield (including the boot disk) with a comma.Ensure that the number of Local SSD disks that you attach is allowed for your machine type; for details, see About Local SSD disks in the Compute Engine documentation.
{ "type": "SCRATCH", "initializeParams": { "diskType": "zones/ZONE/diskTypes/local-ssd" }, "autoDelete": true, "interface": "INTERFACE_TYPE" }Replace the following:
ZONE: your specified zone.INTERFACE_TYPE: the disk interface type that you want to use for the Local SSD disk. If your boot disk image has optimized NVMe drivers, then specifyNVME. SpecifySCSIfor other images.
After creating a VM with Local SSD disks, you must format and mount each device before you can use it.
- Submit the request.
On-demand
Before you submit the request, review all of the following steps to determine whether to include additional fields.
POST https://compute.googleapis.com/compute/v1/projects/PROJECT_ID/zones/ZONE/instances/bulkInsert
{
"namePattern": "NAME_PATTERN",
"count": "COUNT",
"instanceProperties": {
"machineType": "MACHINE_TYPE",
"disks": [
{
"boot": true,
"initializeParams": {
"diskSizeGb": "DISK_SIZE",
"diskType": "DISK_TYPE",
"sourceImage": "projects/IMAGE_PROJECT/global/images/family/IMAGE_FAMILY"
},
"mode": "READ_WRITE",
"type": "PERSISTENT"
}
],
"serviceAccounts": [
{
"email": "default",
"scopes": [
"https://www.googleapis.com/auth/cloud-platform"
]
}
],
"scheduling": {
"provisioningModel": "STANDARD",
"onHostMaintenance": "TERMINATE",
"automaticRestart": AUTOMATIC_RESTART
},
"reservationAffinity": {
"consumeReservationType": "RESERVATION_AFFINITY"
}
}
}
Complete the following steps:
-
Replace the following:
PROJECT_ID: the project ID of the project where you want to create the A2 instance.ZONE: specify a zone in which the machine type that you want to use is available. If you want to specify a compact placement policy, then you must use a zone in the same region as the compact placement policy. For information about regions, see GPU availability by regions and zones.NAME_PATTERN: the name pattern to use for the A2 instances. For example, usinginstance-#for the name pattern generates A2 instances with names such asinstance-1andinstance-2, up to the number of A2 instances specified by--count.COUNT: the number of A2 instances to create.MACHINE_TYPE: the machine type to use for the A2 instance. For more information, see GPU machine types in the Compute Engine documentation.DISK_SIZE: the size of the boot disk in GB. For more information, see either Google Cloud Hyperdisk size limits or Persistent Disk size limits based on the type of disk.DISK_TYPE: the type of the boot disk. For more information about the supported disk types for your machine type, see GPU machines in accelerator-optimized machine family in the Compute Engine documentation.IMAGE_PROJECT: the project ID of the OS image.IMAGE_FAMILY: the image family of the OS image that you want to use. For a list of all supported operating systems, see Supported operating systems.AUTOMATIC_RESTART: if your instance automatically restarts if it crashes or Compute Engine stops it for a programmed stop, such as a maintenance event. Specify eithertrueto enable automatic restart (default) orfalseto disable automatic restart.RESERVATION_AFFINITY: which reservations the instance is allowed to consume, if possible. Specify one of the following:ANY_RESERVATION(Reservation capacity is optional): this is the default option. The instance tries to use capacity from an automatically consumed reservation, which only happens if matching reservation capacity is available. Otherwise, the instance uses on-demand capacity.NO_RESERVATION(On-demand capacity is required): Block the instance from using any reservation capacity.
-
Optional: If you chose to use a compact placement policy, then add the following
instancePropertiessubfield to the request body:"resourcePolicies": [ "projects/PROJECT_ID/regions/REGION/resourcePolicies/POLICY_NAME" ]Replace the following:
PROJECT_ID: the project ID of the compact placement policy.REGION: the region of the compact placement policy.POLICY_NAME: the name of the compact placement policy.
-
Optional: If you specified an A2 Standard machine type and want to attach Local SSD disks, then add the following field to the
disks[]field for each Local SSD disk. Separate eachdisks[]subfield (including the boot disk) with a comma.Ensure that the number of Local SSD disks that you attach is allowed for your machine type; for details, see About Local SSD disks in the Compute Engine documentation.
{ "type": "SCRATCH", "initializeParams": { "diskType": "zones/ZONE/diskTypes/local-ssd" }, "autoDelete": true, "interface": "INTERFACE_TYPE" }Replace the following:
ZONE: your specified zone.INTERFACE_TYPE: the disk interface type that you want to use for the Local SSD disk. If your boot disk image has optimized NVMe drivers, then specifyNVME. SpecifySCSIfor other images.
After creating a VM with Local SSD disks, you must format and mount each device before you can use it.
- Submit the request.
Spot
Before you submit the request, review all of the following steps to determine whether to include additional fields.
POST https://compute.googleapis.com/compute/v1/projects/PROJECT_ID/zones/ZONE/instances/bulkInsert
{
"namePattern": "NAME_PATTERN",
"count": "COUNT",
"instanceProperties": {
"machineType": "MACHINE_TYPE",
"disks": [
{
"boot": true,
"initializeParams": {
"diskSizeGb": "DISK_SIZE",
"diskType": "DISK_TYPE",
"sourceImage": "projects/IMAGE_PROJECT/global/images/family/IMAGE_FAMILY"
},
"mode": "READ_WRITE",
"type": "PERSISTENT"
}
],
"serviceAccounts": [
{
"email": "default",
"scopes": [
"https://www.googleapis.com/auth/cloud-platform"
]
}
],
"scheduling":
{
"provisioningModel": "SPOT",
"instanceTerminationAction": "TERMINATION_ACTION",
"onHostMaintenance": "TERMINATE",
"automaticRestart": false
}
}
}
Complete the following steps:
-
Replace the following:
PROJECT_ID: the project ID of the project where you want to create the A2 instance.ZONE: specify a zone in which the machine type that you want to use is available. If you want to specify a compact placement policy, then you must use a zone in the same region as the compact placement policy. For information about regions, see GPU availability by regions and zones.NAME_PATTERN: the name pattern to use for the A2 instances. For example, usinginstance-#for the name pattern generates A2 instances with names such asinstance-1andinstance-2, up to the number of A2 instances specified by--count.COUNT: the number of A2 instances to create.MACHINE_TYPE: the machine type to use for the A2 instance. For more information, see GPU machine types in the Compute Engine documentation.DISK_SIZE: the size of the boot disk in GB. For more information, see either Google Cloud Hyperdisk size limits or Persistent Disk size limits based on the type of disk.DISK_TYPE: the type of the boot disk. For more information about the supported disk types for your machine type, see GPU machines in accelerator-optimized machine family in the Compute Engine documentation.IMAGE_PROJECT: the project ID of the OS image.IMAGE_FAMILY: the image family of the OS image that you want to use. For a list of all supported operating systems, see Supported operating systems.TERMINATION_ACTION: the action to take when Compute Engine preempts the instance, eitherSTOP(default) orDELETE.
-
Optional: If you chose to use a compact placement policy, then add the following
instancePropertiessubfield to the request body:"resourcePolicies": [ "projects/PROJECT_ID/regions/REGION/resourcePolicies/POLICY_NAME" ]Replace the following:
PROJECT_ID: the project ID of the compact placement policy.REGION: the region of the compact placement policy.POLICY_NAME: the name of the compact placement policy.
-
Optional: If you specified an A2 Standard machine type and want to attach Local SSD disks, then add the following field to the
disks[]field for each Local SSD disk. Separate eachdisks[]subfield (including the boot disk) with a comma.Ensure that the number of Local SSD disks that you attach is allowed for your machine type; for details, see About Local SSD disks in the Compute Engine documentation.
{ "type": "SCRATCH", "initializeParams": { "diskType": "zones/ZONE/diskTypes/local-ssd" }, "autoDelete": true, "interface": "INTERFACE_TYPE" }Replace the following:
ZONE: your specified zone.INTERFACE_TYPE: the disk interface type that you want to use for the Local SSD disk. If your boot disk image has optimized NVMe drivers, then specifyNVME. SpecifySCSIfor other images.
After creating a VM with Local SSD disks, you must format and mount each device before you can use it.
- Submit the request.
For more information about the configuration options when creating VMs in bulk, see Create VMs in bulk in the Compute Engine documentation.
Install GPU drivers
After you create an instance, the instance can't use its GPUs unless the correct GPU drivers are already installed. If you didn't specify an OS image that includes GPU drivers, then see Install GPU drivers in the Compute Engine documentation.
Optional: Enable NVIDIA Multi-Instance GPU mode
Multi-Instance GPU (MIG) mode is a feature that you can enable for a supported NVIDIA GPU. After you create an instance, you can enable MIG mode on a single GPU that is attached to your machine. With MIG mode enabled, the single GPU is partitioned into as many as seven independent GPU instances. Each instance runs simultaneously, each with its own memory, cache, and streaming multiprocessors. You can then run different workloads on these GPU instances in parallel. For more information about using MIG mode, see the Multi-Instance GPU (MIG) User Guide in the NVIDIA documentation.What's next
- View the details of a VM
- Get a list of VMs
- Verify reservation consumption
- Troubleshoot reservation consumption